﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace InfragisticsExampleNotResizing {
    internal class Employee {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Function { get; set; }

        //public BindingList<Task> Tasks { get; set; }
        public BindingList<Task> tasks;

        public BindingList<Task> Tasks
        {
            get
            {
                if (null == this.tasks)
                    this.tasks = new BindingList<Task>();

                return this.tasks;
            }
        }
    }

    internal class Task {
        public int ID { get; set; }
        public string Description { get; set; }
        public string Priority { get; set; }
    }

    internal static class DummyRepository {

        private static BindingList<Task> tasks;
        private static BindingList<Employee> employees;

        internal static BindingList<Employee> Employees
        {
            get 
            {
                if (null == DummyRepository.employees)
                    DummyRepository.employees = new BindingList<Employee>();

                return DummyRepository.employees; 
            }
            set
            {
                if (DummyRepository.employees == value)
                    return;

                DummyRepository.employees = value;
            }
        }

        internal static BindingList<Task> Tasks
        {
            get
            {
                if (null == DummyRepository.tasks)
                    DummyRepository.tasks = new BindingList<Task>();

                return DummyRepository.tasks;
            }
            set
            {
                if (DummyRepository.tasks == value)
                    return;

                DummyRepository.tasks = value;
            }
        }

        internal static void Init() {
            DummyRepository.Tasks = new BindingList<Task>() {new Task() {ID = 1,
                Description = "Task 1 blablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablablabla",
            Priority = "Normal"},
                new Task() {ID = 2,
                Description = "Task 2",
                Priority = "High"},
                new Task() {ID = 3,
                Description = "Task 3",
                Priority = "Low"}};

            DummyRepository.Employees = new BindingList<Employee>() {new Employee() {ID = 1,
                Name = "John",
            Function = "Developer"},
                new Employee() {ID = 2,
                Name = "Peter",
                Function = "Analist"},
                new Employee() {ID = 3,
                Name = "Sarah",
                Function = "Developer"}};
        }



    }
}
